<?php
/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Base;


use Provider\Auth\SessionUserTrait;
use Provider\Response\Results;
use RuntimeException;

class BaseHelper
{
	use SessionUserTrait;

	protected $response;
	protected $model = "";

	public function __construct()
	{
		$this->response = new Results();
		if ($this->model == "") {
			throw new RuntimeException("Model isnot Intialized");
		}
		$this->model = new $this->model();
	}

	public function setInput($input)
	{
		if (is_array($input)) {
			foreach ($input as $key => $value) {
				if (property_exists($this, $key)) {
					$this->$key = $value;
				}
			}
		}
		return $this;
	}

	public function beforeInsert($input)
	{
		return $this;
	}

	public function beforeSoftDelete($input, $id)
	{
		return $this;
	}

	public function beforeDelete($id)
	{
		return $this;
	}

	public function beforeUpdate($input, $id)
	{
		return $this;
	}

	public function beforeBulkDelete($input, $id)
	{
		return $this;
	}

	public function store()
	{
		return;
	}

	public function storeWithRelation()
	{
		return;
	}

	public function storeFromRelation($id, $input)
	{
		return;
	}
}